SystemOrganization addCategory: #'JiffyCard-Core'!

ALApplication subclass: #JiffyCardApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JiffyCardApplication methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 09:48'!
initializeLocator
	locator 
		at: ALPath root 
		put: JCHomePage new asResource! !

Object subclass: #JCController
	instanceVariableNames: 'snapshot delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCController subclass: #JCComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCComponent methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:05'!
decoration

	^ decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:05'!
decoration: anObject

	decoration := anObject! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 09:52'!
initialize
	decoration := JCMessage new next: self! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/26/2017 10:05'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCComponent subclass: #JCCounter
	instanceVariableNames: 'count parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCounter methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 20:34'!
answer
	parent main clearDelegate! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
count

	^ count! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
count: anObject

	count := anObject! !

!JCCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:16'!
initialize
	super initialize.
	count := 0.
	"delegate := BGHelloWorld new. "! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
parent

	^ parent! !

!JCCounter methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:40'!
parent: anObject

	parent := anObject! !

!JCCounter methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 20:35'!
renderContentOn: html
	html a navigate: [count := count + 1]; with: '++'.
	html br.
	html span with: count asString.
	html br. 
	html a navigate: [count := count - 1]; with: '--'.
	html br.
	html a callback: [ self answer ]; with: 'Answer And Return'! !

JCComponent subclass: #JCHelloJupiter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHelloJupiter methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:03'!
renderContentOn: html
	html p: 'Hello Jupiter'! !

JCComponent subclass: #JCHelloMars
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHelloMars methodsFor: 'as yet unclassified' stamp: 'chc 4/20/2017 09:44'!
renderContentOn: html
	html p: 'Hello Mars'! !

JCComponent subclass: #JCHelloWorld
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 09:47'!
call
	 main delegate: (JCCounter new parent: self)! !

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 09:50'!
initialize
	main := JCHelloMars new! !

!JCHelloWorld methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:55'!
main

	^ main! !

!JCHelloWorld methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:55'!
main: anObject

	main := anObject! !

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 20:34'!
renderContentOn: html
	html div id: 'border'; with: [html p: 'Hello World'].
	html div id: 'border'; with: main.
	html a callback: [ self call ]; with: 'Next Delegate'! !

!JCController methodsFor: 'call/answer' stamp: 'chc 4/21/2017 08:59'!
call: aRenderable
	self delegate: (aRenderable new parent: self)! !

!JCController methodsFor: 'delegate' stamp: 'chc 4/21/2017 08:47'!
clearDelegate
	self delegate: nil! !

!JCController methodsFor: 'delegate' stamp: 'chc 4/21/2017 08:21'!
delegate

	^ delegate! !

!JCController methodsFor: 'delegate' stamp: 'chc 4/21/2017 08:21'!
delegate: anObject

	delegate := anObject! !

!JCController methodsFor: 'rendering' stamp: 'chc 5/21/2017 21:05'!
renderOn: html
	|del|
	del := delegate.
	del
		ifNil: [ self decoration renderContentOn: html]
		ifNotNil: [ delegate renderOn: html ]! !

!JCController methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:21'!
snapshot

	^ snapshot! !

!JCController methodsFor: 'accessing' stamp: 'chc 4/21/2017 08:21'!
snapshot: anObject

	snapshot := anObject! !

JCController subclass: #JCDecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next

	^ next! !

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next: anObject

	next := anObject! !

!JCDecoration methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:10'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCDecoration subclass: #JCMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCMessage methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:12'!
renderContentOn: html
	html p: 'Hello From The Antibes'.
	next renderContentOn: html ! !

Object subclass: #JCHomePage
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHomePage methodsFor: 'converting' stamp: 'chc 5/30/2017 09:48'!
asResource
	^ JCHtmlResource component: self! !

!JCHomePage methodsFor: 'initialize-release' stamp: 'chc 5/30/2017 09:49'!
initialize
	root := JCHelloJupiter new! !

!JCHomePage methodsFor: 'rendering' stamp: 'chc 4/27/2017 10:01'!
renderBodyOn: html
	html div
		with: [root renderOn: html]! !

!JCHomePage methodsFor: 'rendering' stamp: 'chc 4/27/2017 10:01'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'BlackGold'.
			 html style: 
				'#border {
					border: thin solid #aaa;
					margin-left: 8px;
					margin-right: 8 px;}'].
	html body: [ self renderBodyOn: html ] ]! !

ALComponentResource subclass: #JCHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !
